# MapperReadKeyValueRepo

open class MapperReadKeyValueRepo < FromKey , FromValue , ToKey , ToValue >(to: ReadKeyValueRepo < ToKey , ToValue >, mapper: MapperRepo < FromKey , FromValue , ToKey , ToValue >) : ReadKeyValueRepo < FromKey , FromValue > , MapperRepo < FromKey , FromValue , ToKey , ToValue > (source)

Read-only key-value repository adapter that applies type mapping via MapperRepo. Converts outer (From) key/value types to inner (To) types before delegating to to, and converts results back from inner to outer types.

#### Parameters

to

The underlying ReadKeyValueRepo to delegate operations to

mapper

The MapperRepo providing bidirectional key/value type conversions

#### Type Parameters

FromKey

The outer key type exposed by this repo

FromValue

The outer value type exposed by this repo

ToKey

The inner key type used by the underlying to repo

ToValue

The inner value type used by the underlying to repo

## Constructors

MapperReadKeyValueRepo
Link copied to clipboard
constructor(to: ReadKeyValueRepo < ToKey , ToValue >, mapper: MapperRepo < FromKey , FromValue , ToKey , ToValue >)

## Properties

keyMapper
Link copied to clipboard
open override val keyMapper : SimpleSuspendableMapper < FromKey , ToKey >

Provides a mapper for converting keys between inner and outer types.

valueMapper
Link copied to clipboard
open override val valueMapper : SimpleSuspendableMapper < FromValue , ToValue >

Provides a mapper for converting values between inner and outer types.

## Functions

asReadCRUDRepo
Link copied to clipboard
fun < K , V > ReadKeyValueRepo < K , V >. asReadCRUDRepo (): ReadCRUDFromKeyValueRepo < V , K >

Wraps this ReadKeyValueRepo as a ReadCRUDFromKeyValueRepo, exposing CRUD read operations.

asReadKeyValuesRepo
Link copied to clipboard
fun < K , V , VI : Iterable < V >> ReadKeyValueRepo < K , VI >. asReadKeyValuesRepo (): ReadKeyValuesFromKeyValueRepo < K , V , VI >

Wraps this ReadKeyValueRepo (mapping keys to iterables) as a ReadKeyValuesFromKeyValueRepo, exposing a one-to-many read interface.

cached
Link copied to clipboard
fun < Key , Value > ReadKeyValueRepo < Key , Value >. cached (kvCache: KVCache < Key , Value >, locker: SmartRWLocker = SmartRWLocker()): ReadKeyValueCacheRepo < Key , Value >
fun < Key , Value > ReadKeyValueRepo < Key , Value >. cached (kvCache: KeyValueRepo < Key , Value >, locker: SmartRWLocker = SmartRWLocker()): FullReadKeyValueCacheRepo < Key , Value >
contains
Link copied to clipboard
open suspend override fun contains (key: FromKey ): Boolean
count
Link copied to clipboard
open suspend override fun count (): Long
diff
Link copied to clipboard
suspend fun < Id , Registered > ReadKeyValueRepo < Id , Registered >. diff (other: Map < Id , Registered >): MapDiff < Id , Registered >

Computes the difference between all entries in this ReadKeyValueRepo and the given other map.

directlyCached
Link copied to clipboard
fun < Key , Value > ReadKeyValueRepo < Key , Value >. directlyCached (kvCache: KeyValueRepo < Key , Value >, locker: SmartRWLocker = SmartRWLocker()): DirectFullReadKeyValueCacheRepo < Key , Value >
get
Link copied to clipboard
open suspend override fun get (k: FromKey ): FromValue ?
getAll
Link copied to clipboard
open suspend override fun getAll (): Map < FromKey , FromValue >

Returns all key-value pairs in the repository as a Map. Default implementation iterates all pages using keys and get.

keys
Link copied to clipboard
open suspend override fun keys (pagination: Pagination , reversed: Boolean = false): PaginationResult < FromKey >

This method should use sorted by Keys search and return the PaginationResult. By default, it should use ascending sort for Keys

open suspend override fun keys (v: FromValue , pagination: Pagination , reversed: Boolean = false): PaginationResult < FromKey >

This method should use sorted by Keys search and return the PaginationResult. By default, it should use ascending sort for Keys.

maxPagePagination
Link copied to clipboard
inline suspend fun ReadKeyValueRepo <*, *>. maxPagePagination (): SimplePagination

Creates a pagination starting from the first page with size equal to the total count of items in this ReadKeyValueRepo. This effectively creates a single page containing all items.

toInnerKey
Link copied to clipboard
open suspend override fun ToKey . toInnerKey (): FromKey

Converts a key from the outer type to the inner type.

toInnerValue
Link copied to clipboard
open suspend override fun ToValue . toInnerValue (): FromValue

Converts a value from the outer type to the inner type.

toOutKey
Link copied to clipboard
open suspend override fun FromKey . toOutKey (): ToKey

Converts a key from the inner type to the outer type.

toOutValue
Link copied to clipboard
open suspend override fun FromValue . toOutValue (): ToValue

Converts a value from the inner type to the outer type.

values
Link copied to clipboard
open suspend override fun values (pagination: Pagination , reversed: Boolean = false): PaginationResult < FromValue >

This method should use sorted by Keys search and return the PaginationResult. By default, it should use ascending sort for Keys

withMapper
Link copied to clipboard
inline fun < FromKey , FromValue , ToKey , ToValue > ReadKeyValueRepo < ToKey , ToValue >. withMapper (mapper: MapperRepo < FromKey , FromValue , ToKey , ToValue >): ReadKeyValueRepo < FromKey , FromValue >

Wraps this ReadKeyValueRepo with a MapperRepo to expose a mapped ReadKeyValueRepo.

inline fun < FromKey , FromValue , ToKey , ToValue > ReadKeyValueRepo < ToKey , ToValue >. withMapper (noinline keyFromToTo: suspend FromKey .() -> ToKey = { this as ToKey }, noinline valueFromToTo: suspend FromValue .() -> ToValue = { this as ToValue }, noinline keyToToFrom: suspend ToKey .() -> FromKey = { this as FromKey }, noinline valueToToFrom: suspend ToValue .() -> FromValue = { this as FromValue }): ReadKeyValueRepo < FromKey , FromValue >

Wraps this ReadKeyValueRepo with inline conversion lambdas to expose a mapped ReadKeyValueRepo.